// Java 3DeXgpAvbg
// AppearanceTest.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@timedia.co.jp
//                      http://www.javaopen.org/j3dbook/index.html

import java.applet.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;

public class AppearanceTest extends Applet {
  public AppearanceTest() {
    GraphicsConfiguration config =
      SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas = new Canvas3D(config);
    this.setLayout(new BorderLayout());
    this.add(canvas, BorderLayout.CENTER);

    SimpleUniverse universe = new SimpleUniverse(canvas);
    universe.getViewingPlatform().setNominalViewingTransform();

    BranchGroup scene = createSceneGraph();

    universe.addBranchGraph(scene);
  }

  private BranchGroup createSceneGraph() {
    BranchGroup root = new BranchGroup();

    Point3d[] vleft = new Point3d[3];
    
    vleft[0] = new Point3d(-0.9, 0.0, 0.0);
    vleft[1] = new Point3d(-0.6, -0.4, 0.0);
    vleft[2] = new Point3d(-0.2, 0.3, 0.0);
    
    PointArray gleft = new PointArray(vleft.length, GeometryArray.COORDINATES);
    gleft.setCoordinates(0, vleft);
    
    PointAttributes pleft = new PointAttributes();
    pleft.setPointSize(12.0f);
    
    Appearance aleft = new Appearance();
    aleft.setPointAttributes(pleft);

    Shape3D sleft = new Shape3D(gleft, aleft);
    
    root.addChild(sleft);

    Point3d[] vright = new Point3d[3];

    vright[0] = new Point3d(0.1, 0.0, 0.0);
    vright[1] = new Point3d(0.3, -0.4, 0.0);
    vright[2] = new Point3d(0.6, 0.1, 0.0);

    PointArray gright = new PointArray(vright.length, GeometryArray.COORDINATES);
    gright.setCoordinates(0, vright);

    PointAttributes pright = new PointAttributes();
    pright.setPointSize(12.0f);
    pright.setPointAntialiasingEnable(true);

    Appearance aright = new Appearance();
    aright.setPointAttributes(pright);
    
    Shape3D sright = new Shape3D(gright, aright);

    root.addChild(sright);

    return root;
  }

  public static void main(String[] args) {
    AppearanceTest applet = new AppearanceTest();
    MainFrame frame = new MainFrame(applet, 500, 500);
  }
}
