// Java 3D Test Program
// ColorEnevt.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html


import java.util.EventObject;
import javax.vecmath.Tuple3f;
import javax.vecmath.Color3f;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;
import javax.vecmath.Tuple4f;
import javax.vecmath.Color4f;
import javax.vecmath.Point4f;
import javax.vecmath.Vector4f;
import javax.vecmath.Quat4f;

public class TupleEvent extends EventObject {
  protected Tuple3f tuple3f = null;
  protected Tuple4f tuple4f = null;
  public TupleEvent(Object source, Tuple3f tuple) {
    super(source);
    tuple3f = tuple;
  }
  public TupleEvent(Object source, Tuple4f tuple) {
    super(source);
    tuple4f = tuple;
  }
  public Tuple3f getTuple3f() { return tuple3f; }
  public Color3f getColor3f() { return (Color3f)tuple3f; }
  public Point3f getPoint3f() { return (Point3f)tuple3f; }
  public Vector3f getVector3f() { return (Vector3f)tuple3f; }
  public Tuple4f getTuple4f() { return tuple4f; }
  public Color4f getColor4f() { return (Color4f)tuple4f; }
  public Point4f getPoint4f() { return (Point4f)tuple4f; }
  public Vector4f getVector4f() { return (Vector4f)tuple4f; }
  public Quat4f getQuat4f() { return (Quat4f)tuple4f; }
}
