// Java 3Dƥȥץ
// WallCollisionBehavior.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class WallCollisionBehavior extends Behavior {
  public static final int USE_BOUNDS = WakeupOnCollisionMovement.USE_BOUNDS;
  public static final int USE_GEOMETRY = WakeupOnCollisionMovement.USE_GEOMETRY;

  private static final Vector3d ORIGIN = new Vector3d(0.0, 0.0, 0.0); // 
  private static final double VSCALE = 0.1;      // ͻΰư

  private Transform3D ot3d = new Transform3D();  // ͤΤʪΤT3D
  private TransformGroup otrans = null;          // ͤΤʪΤTG
  private Node onode = null;                     // ͤΤʪ
  private Vector3d ovector = null;               // ͤΤʪΤοʹ

  private Transform3D nt3d = new Transform3D();  // ɤT3D
  private Transform3D rt3d = new Transform3D();  // ͤˤư

  private int hint = USE_BOUNDS;                 // ΰ踡Ū
  private WakeupOnCollisionMovement move = null; // Behaviorư

  public WallCollisionBehavior(TransformGroup trans, Node node, Vector3d vector) {
    this(trans, node, vector, USE_BOUNDS);
  }

  public WallCollisionBehavior(TransformGroup trans, Node node, Vector3d vector, int hint) {
    onode = node;
    otrans = trans;
    ovector = vector;
    hint = hint;
  }

  public void initialize() {
    move = new WakeupOnCollisionMovement(onode, hint);
    wakeupOn(move);
  }

  public void processStimulus(Enumeration criteria) {
    while (criteria.hasMoreElements()) {
      WakeupOnCollisionMovement wakeup =
	(WakeupOnCollisionMovement)criteria.nextElement();
      SceneGraphPath npath = wakeup.getTriggeringPath(); // ͤɤޤPath
      Node node = npath.getObject();
      System.out.println("\nnode.getBounds()=" + node.getBounds());//DEBUG
      System.out.println("onode.getBounds()=" + onode.getBounds());//DEBUG
      TransformGroup ntrans = (TransformGroup)node.getUserData();//ɤ˥åȤƤäTG
      if (ntrans != null) {
	ntrans.getTransform(nt3d);                        // ɤT3D
	System.out.println("nt3d=\n" + nt3d);//DEBUG
	nt3d.setTranslation(ORIGIN);                      // ᤷƤ
	Vector3d nvec = new Vector3d(0.0, 0.0, 1.0);      // ɤˡ٥ȥ
	nt3d.transform(nvec);                             // ɤˡ٥ȥ׻
	
	otrans.getTransform(ot3d);                        // T3D
	System.out.println("o.x=" + ovector.x + ", o.y=" + ovector.y + ", o.z=" + ovector.z);//DEBUG
	System.out.println("ot3d=\n" + ot3d);//DEBUG
	ot3d.setTranslation(ORIGIN);                      // ᤷƤ
	ot3d.transpose();                                 // ޥȥåž
	ot3d.transform(nvec);                             // ɤˡɸѴ
	System.out.println("n.x=" + nvec.x + ", n.y=" + nvec.y + ", n.z=" + nvec.z);//DEBUG
       
	Vector3d onegate = new Vector3d();                // ʪΤεե٥ȥ
	onegate.negate(ovector);                          // ե٥ȥ׻
	double odotn = onegate.dot(nvec);                 //  ON
	System.out.println("odotn=" + odotn);//DEBUG	  
	nvec.scale(2.0 * odotn);                          // 2(ON)N
	System.out.println("n.x=" + nvec.x + ", n.y=" + nvec.y + ", n.z=" + nvec.z);//DEBUG
	Vector3d rvec = new Vector3d(nvec);               // ȿͥ٥ȥ
	rvec.sub(nvec, onegate);                          // 2(ON)N - O // Phong μ
	rvec.normalize();                                 // 
	rvec.scale(VSCALE);                               // ư̤ǥ顼
	System.out.println("r.x=" + rvec.x + ", r.y=" + rvec.y + ", r.z=" + rvec.z);//DEBUG
	rt3d.set(rvec);                                   // ư٥ȥ򥻥åȤ
	
	otrans.getTransform(ot3d);                        // ⤦ٸߤTransform
	ot3d.mul(rt3d);                                   // ư軻
	otrans.setTransform(ot3d);                        // ư
      }
    }

    wakeupOn(move);
  }

  public Node cloneNodeComponent(boolean forceDuplication) {
     WallCollisionBehavior wallCollisionBehavior =
       new WallCollisionBehavior(otrans, onode, ovector, hint);
     wallCollisionBehavior.duplicateNode(this, forceDuplication);
     return wallCollisionBehavior;
  }

  public void duplicateNode(Node node, boolean forceDuplication) {
    super.duplicateNode(node, forceDuplication);
  }

  public void updateNodeReference(NodeReferenceTable table) {
    super.updateNodeReferences(table);

    Node newNode =
      (Node)table.getNewObjectReference(onode);
    onode = newNode;

    TransformGroup newTransformGroup = 
      (TransformGroup)table.getNewObjectReference(otrans);
    otrans = newTransformGroup;
  }

}


