// Java 3DeXgpAvbg
// FirstApplet.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import java.applet.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.geometry.ColorCube;

public class FirstApplet extends Applet {
  public FirstApplet() {
    GraphicsConfiguration config =
      SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas = new Canvas3D(config);
    this.setLayout(new BorderLayout());
    this.add(canvas, BorderLayout.CENTER);

    SimpleUniverse universe = new SimpleUniverse(canvas);
    universe.getViewingPlatform().setNominalViewingTransform();

    BranchGroup scene = createSceneGraph();

    universe.addBranchGraph(scene);
  }

  private BranchGroup createSceneGraph() {
    BranchGroup root = new BranchGroup();

    Transform3D t3d = new Transform3D();
    t3d.setRotation(
      new AxisAngle4d(0.57, 0.57, -0.57, Math.PI / 4.0));

    Transform3D scaling = new Transform3D();
    scaling.setScale(new Vector3d(0.2, 0.8, 1.8));

    t3d.mul(scaling);

    TransformGroup trans = new TransformGroup(t3d);
    
    trans.addChild(new ColorCube(0.4));

    root.addChild(trans);

    return root;
  }

  public static void main(String[] args) {
    FirstApplet applet = new FirstApplet();
    MainFrame frame = new MainFrame(applet, 500, 500);
  }
}
