// Java 3D Test Applet
// LightingApplet.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import java.applet.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.geometry.Sphere;

public class LightingApplet extends Applet {
  public LightingApplet() {
    GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas = new Canvas3D(config);
    this.setLayout(new BorderLayout());
    this.add(canvas, BorderLayout.CENTER);
    
    SimpleUniverse universe = new SimpleUniverse(canvas);
    universe.getViewingPlatform().setNominalViewingTransform();
    
    universe.addBranchGraph(createSceneGraph());
  }
  
  private BranchGroup createSceneGraph() {
    BranchGroup root = new BranchGroup();
    
    DirectionalLight light = new DirectionalLight();
    Color3f color = new Color3f();
    light.getColor(color);
    System.out.println("red=" + color.x + ", green=" + color.y + ", blue=" + color.z);
    Vector3f vector = new Vector3f();
    light.getDirection(vector);
    System.out.println("x=" + vector.x + ", y=" + vector.y + ", z=" + vector.z);
    BoundingSphere bounds = new BoundingSphere(new Point3d(), 100.0);
    light.setInfluencingBounds(bounds);
    root.addChild(light);

    Sphere sphere = new Sphere(0.6f);
    root.addChild(sphere);
    
    return root;
  }

  public static void main(String[] args) {
    LightingApplet applet = new LightingApplet();
    Frame frame = new MainFrame(applet, 500, 500);
  }
}
