// Java 3D Test Applet
// LightingApplet.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import java.applet.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.geometry.Sphere;

public class LightingApplet extends Applet {
  public LightingApplet() {
    GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas = new Canvas3D(config);
    this.setLayout( new BorderLayout() );
    this.add(canvas, BorderLayout.CENTER);
    
    SimpleUniverse universe = new SimpleUniverse(canvas);
    universe.getViewingPlatform().setNominalViewingTransform();
    
    universe.addBranchGraph(createSceneGraph());
  }
  
  private BranchGroup createSceneGraph() {
    BranchGroup root = new BranchGroup();
    
    BoundingSphere bounds = new BoundingSphere(new Point3d(), 100.0);
    SpotLight light1 =
      new SpotLight( new Color3f(1.0f, 1.0f, 1.0f),
                     new Point3f(0.5f, 0.5f, 0.8f),
                     new Point3f(1.0f, 0.0f, 0.0f),
                     new Vector3f(-0.5f, -0.5f, -0.7f),
                     (float)(Math.PI / 7.0),
                     0.0f );
    light1.setInfluencingBounds(bounds);
    root.addChild(light1);

    SpotLight light2 =
      new SpotLight( new Color3f(1.0f, 1.0f, 1.0f),
                     new Point3f(-0.5f, -0.5f, 0.8f),
                     new Point3f(1.0f, 0.0f, 0.0f),
                     new Vector3f(0.5f, 0.5f, -0.7f),
                     (float)(Math.PI / 7.0),
                     20.0f );
    light2.setInfluencingBounds(bounds);
    root.addChild(light2);

    Sphere sphere = new Sphere(0.6f, Sphere.GENERATE_NORMALS, 100);
    root.addChild(sphere);
    
    return root;
  }

  public static void main(String[] args) {
    LightingApplet applet = new LightingApplet();
    Frame frame = new MainFrame(applet, 500, 500);
  }
}
