// Java 3DeXgpvO
// NormalRedner.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import javax.media.j3d.*;
import javax.vecmath.*;

public class NormalRender {
  private LineArray nline = null;
  public NormalRender(GeometryArray geom) { this(geom, 1.0f); }
  public NormalRender(GeometryArray geom, float scale) {
    Point3f[] vertices = new Point3f[geom.getVertexCount()];
    Vector3f[] normals = new Vector3f[geom.getVertexCount()];
    for (int i=0; i<geom.getVertexCount(); i++) {
      vertices[i] = new Point3f();
      normals[i] = new Vector3f();
    }
    geom.getCoordinates(0, vertices);
    geom.getNormals(0, normals);
    Point3f[] nvertices = new Point3f[vertices.length * 2];
    int n = 0;
    for (int i=0; i<vertices.length; i++ ){
      nvertices[n++] = new Point3f( vertices[i] );
      nvertices[n++] = new Point3f( vertices[i].x + scale * normals[i].x,
				    vertices[i].y + scale * normals[i].y,
				    vertices[i].z + scale * normals[i].z );
    }
    nline = new LineArray(nvertices.length, GeometryArray.COORDINATES);
    nline.setCoordinates(0, nvertices);
  }

  public LineArray getLineArray() { return nline; }
}
