// Java 3DeXgpAvbg
// Shape3DTest.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import java.applet.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;

public class Shape3DTest extends Applet {
  public Shape3DTest() {
    GraphicsConfiguration config =
      SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas = new Canvas3D(config);
    this.setLayout(new BorderLayout());
    this.add(canvas, BorderLayout.CENTER);

    SimpleUniverse universe = new SimpleUniverse(canvas);
    universe.getViewingPlatform().setNominalViewingTransform();

    BranchGroup scene = createSceneGraph();

    universe.addBranchGraph(scene);
  }

  private BranchGroup createSceneGraph() {
    BranchGroup root = new BranchGroup();

    Point3d[] vertices = new Point3d[15];
    
    vertices[0] = new Point3d(-0.9, -0.6, 0.0);
    vertices[1] = new Point3d(-0.5, -0.8, 0.0);
    vertices[2] = new Point3d(-0.5, -0.4, 0.0);
    vertices[3] = new Point3d(0.0, -0.6, 0.0);
    vertices[4] = new Point3d(0.0, -0.2, 0.0);
    vertices[5] = new Point3d(0.4, -0.3, 0.0);
    vertices[6] = new Point3d(0.5, 0.1, 0.0);
    vertices[7] = new Point3d(0.8, 0.0, 0.0);
    vertices[8] = new Point3d(-0.8, 0.2, 0.0);
    vertices[9] = new Point3d(-0.6, 0.0, 0.0);
    vertices[10] = new Point3d(-0.6, 0.5, 0.0);
    vertices[11] = new Point3d(-0.3, 0.3, 0.0);
    vertices[12] = new Point3d(-0.2, 0.6, 0.0);
    vertices[13] = new Point3d(0.1, 0.5, 0.0);
    vertices[14] = new Point3d(0.0, 0.8, 0.0);
    
    int[] stripVertexCounts = { 8, 7 };
    
    TriangleStripArray geometry = new TriangleStripArray(
      vertices.length, GeometryArray.COORDINATES, stripVertexCounts);
    geometry.setCoordinates(0, vertices);
    
    Shape3D shape = new Shape3D(geometry);
    
    root.addChild(shape);

    return root;
  }

  public static void main(String[] args) {
    Shape3DTest applet = new Shape3DTest();
    MainFrame frame = new MainFrame(applet, 500, 500);
  }
}
