// Java 3DeXgpAvbg
// Shape3DTest.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import java.applet.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;

public class Shape3DTest extends Applet {
  public Shape3DTest() {
    GraphicsConfiguration config =
      SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas = new Canvas3D(config);
    this.setLayout(new BorderLayout());
    this.add(canvas, BorderLayout.CENTER);

    SimpleUniverse universe = new SimpleUniverse(canvas);
    universe.getViewingPlatform().setNominalViewingTransform();

    BranchGroup scene = createSceneGraph();

    universe.addBranchGraph(scene);
  }

  private BranchGroup createSceneGraph() {
    BranchGroup root = new BranchGroup();

    Point3d[] vertices = new Point3d[3];
    
    vertices[0] = new Point3d(-0.6, 0.7, 0.0);
    vertices[1] = new Point3d(-0.4, -0.8, 0.0);
    vertices[2] = new Point3d(0.5, -0.4, 0.0);
    
    int[] indices = { 2, 0, 1 };
    
    IndexedPointArray geometry =
      new IndexedPointArray(vertices.length, GeometryArray.COORDINATES, indices.length);
    geometry.setCoordinates(0, vertices);
    geometry.setCoordinateIndices(0, indices);
    
    Shape3D shape = new Shape3D(geometry);
    
    root.addChild(shape);

    return root;
  }

  public static void main(String[] args) {
    Shape3DTest applet = new Shape3DTest();
    MainFrame frame = new MainFrame(applet, 500, 500);
  }
}
