// Java 3Dƥѥץ// SimplePicking.java
//   Copyright (c) 1999 ENDO Yasuyuki
//                      mailto:yasuyuki@javaopen.org
//                      http://www.javaopen.org/j3dbook/index.html

import javax.media.j3d.*;
import com.sun.j3d.utils.picking.PickTool;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.picking.behaviors.PickMouseBehavior;

public class SimplePicking extends PickMouseBehavior {
  protected SimplePickingCallback callback = null;
  protected int pickMode = PickTool.BOUNDS;
  protected int nodeType = PickResult.SHAPE3D;

  public SimplePicking(BranchGroup root, Canvas3D canvas, Bounds bounds) {
    super(canvas, root, bounds);

    this.setSchedulingBounds(bounds);
  }

  public SimplePicking( BranchGroup root, Canvas3D canvas, Bounds bounds,
		        int mode )
  {
    super(canvas, root, bounds);
    pickMode = mode;

    this.setSchedulingBounds(bounds);
  }

  public SimplePicking( BranchGroup root, Canvas3D canvas, Bounds bounds,
		        int mode, int type)
  {
    super(canvas, root, bounds);
    pickMode = mode;
    nodeType = type;

    this.setSchedulingBounds(bounds);
  }

  public void setPickMode(int mode) { pickMode = mode; }
  public int getPickMode() { return pickMode; }

  public void setNodeType(int type) { nodeType = type; }
  public int getNodeType() { return nodeType; }

  public void setupCallback(SimplePickingCallback callback) { this.callback = callback; }

  public void updateScene(int x, int y) {
    pickCanvas.setShapeLocation(x, y);
    PickResult pickResult = pickCanvas.pickClosest();
    //System.out.println(pickResult);//DEBUG
    Node node = pickResult.getNode(nodeType);
    callback.picked(nodeType, node);
  }
}
